import GppCompiler from "../Compiler/GppCompiler";
import HaveCompiler from "./interface/HaveCompiler";
import Optimize from "./interface/Optimize";
import SourceFiles from "./interface/SourceFiles";
import Project from "./Project";

export default class CppProject implements Project , SourceFiles,HaveCompiler,Optimize {
    name: string;
    compiler: GppCompiler;
    sourceFiles: string[]=[];
    optimize: "fast" | "fastest" | "normal" = "fast"

    constructor(name:string)
    constructor(name:string,compiler:GppCompiler)

    constructor(name:string,compiler?:GppCompiler){
        if(compiler){
            this.compiler=compiler
        }else{
            this.compiler=new GppCompiler()
        }
        this.name=name
        
    }
}